" Original version from Georg Dahn (2008)
" Modified by PowerGod (2016)

if version < 600
    syntax clear
elseif exists("b:current_syntax")
    finish
endif

syn case ignore
syn spell toplevel

syn match bbcodeItem contained "\[\s*[-a-zA-Z0-9]\+"hs=s+1 contains=@NoSpell
syn match bbcodeItem contained "\[/\s*[-a-zA-Z0-9]\+"hs=s+2 contains=@NoSpell
syn match bbcodeItem contained "\[\s*\*\s*\]"hs=s+1,he=e-1 contains=@NoSpell
syn match bbcodeArgument contained "\s[-a-zA-Z0-9]\+\s*="ms=s+1,me=e-1 contains=@NoSpell
syn region bbcodeValue contained start="\"" end="\"" contains=@NoSpell
"syn region bbcodeValue contained start="'" end="'" contains=@NoSpell
syn match bbcodeValue contained "=[\t ]*[^'" \t\]][^ \t\]]*"hs=s+1 contains=@NoSpell
syn region bbcodeTag start="\[/\{0,1}" end="\]" contains=@NoSpell,bbcodeItem,bbcodeArgument,bbcodeValue

syn region bbcodeBold start="\[b\]" end="\[/b\]"me=e-4 contains=bbcodeTag,bbcodeBoldItalic,bbcodeBoldUnderline
syn region bbcodeBoldItalic contained start="\[i\]" end="\[/i\]"me=e-4 contains=bbcodeTag,bbcodeBoldItalicUnderline
syn region bbcodeBoldItalicUnderline contained start="\[u\]" end="\[/u\]"me=e-4 contains=bbcodeTag
syn region bbcodeBoldUnderline contained start="\[u\]" end="\[/u\]"me=e-4 contains=bbcodeTag,bbcodeBoldUnderlineItalic
syn region bbcodeBoldUnderlineItalic contained start="\[i\]" end="\[/i\]"me=e-4 contains=bbcodeTag

syn region bbcodeItalic start="\[i\]" end="\[/i\]"me=e-4 contains=bbcodeTag,bbcodeItalicBold,bbcodeItalicUnderline
syn region bbcodeItalicBold contained start="\[b\]" end="\[/b\]"me=e-4 contains=bbcodeTag,bbcodeItalicBoldUnderline
syn region bbcodeItalicBoldUnderline contained start="\[u\]" end="\[/u\]"me=e-4 contains=bbcodeTag
syn region bbcodeItalicUnderline contained start="\[u\]" end="\[/u\]"me=e-4 contains=bbcodeTag,bbcodeItalicUnderlineBold
syn region bbcodeItalicUnderlineBold contained start="\[b\]" end="\[/b\]"me=e-4 contains=bbcodeTag

syn region bbcodeUnderline start="\[u\]" end="\[/u\]"me=e-4 contains=bbcodeTag,bbcodeUnderlineBold,bbcodeUnderlineItalic
syn region bbcodeUnderlineBold contained start="\[b\]" end="\[/b\]"me=e-4 contains=bbcodeTag,bbcodeUnderlineBoldItalic
syn region bbcodeUnderlineBoldItalic contained start="\[i\]" end="\[/i\]"me=e-4 contains=bbcodeTag
syn region bbcodeUnderlineItalic contained start="\[i\]" end="\[/i\]"me=e-4 contains=bbcodeTag,bbcodeUnderlineItalicBold
syn region bbcodeUnderlineItalicBold contained start="\[b\]" end="\[/b\]"me=e-4 contains=bbcodeTag

syn region bbcodeUrl start="\[url\s*[=\]]" end="\[/url\]"me=e-6 contains=@NoSpell,bbcodeTag

" syn region bbcodeCode matchgroup=Delimiter start="/\[code\(=.\{-}\)\?\]/" end="/\[\/code\]/"
"syn region bbcodeCode matchgroup=Delimiter start="\[code\(=.\{-}\)\?\]"he=e+6 end="\[\/code\]"me=e-7
syn region bbcodeCode matchgroup=Statement start="\[code\(=.\{-}\)\?\]"he=e+6 end="\[\/code\]"me=e-7

" Definitions for matchit.vim (to jump from starting to closing tags) 
" (using % jumps from [LIST], [*] and [/LIST], else from the starting tag to the closing tag)
"let b:match_words = '\[LIST\]:\[\*\]:\[/LIST\],\[[^/]\{-}\]:\[/.\{-}\]'
"let b:match_words = '\[LIST\(=.\{-}\)\?\]:\[\*\]:\[/LIST\],\[[^/]\{-}\]:\[/.\{-}\]'
"with \{-} does not find the starting tag, so I must use .*
let b:match_words = '\[LIST\(=.*\)\?\]:\[\*\]:\[/LIST\],\[[^/]\{-}\]:\[/.\{-}\]'

" CODE TO DO SOME TRIALS TO CATCH EXCEDING FINAL TAGS
"catch errors caused by wrong parenthesis
"syn region vfpParen transparent start='(' end=')' contains=ALLBUT,vfpParenErr
"syn match vfpParenErr ")"

" Define the default highlighting.
" For version 5.7 and earlier: only when not done already
" For version 5.8 and later: only when an item doesn't have highlighting yet
if version >= 508 || !exists("did_vfp_syn_inits")
	if version < 508
		let did_vfp_syn_inits = 1
		command -nargs=+ HiLink hi link <args>
	else
		command -nargs=+ HiLink hi def link <args>
	endif

	HiLink bbcodeTag Identifier
	HiLink bbcodeItem Statement
	HiLink bbcodeArgument Type
	HiLink bbcodeValue Constant
	HiLink bbcodeUrl Underlined
	HiLink bbcodeCode PreProc
"	HiLink vfpParenErr Error

	HiLink bbcodeBoldUnderlineItalic bbcodeBoldItalicUnderline
	HiLink bbcodeItalicBold bbcodeBoldItalic
	HiLink bbcodeItalicBoldUnderline bbcodeBoldItalicUnderline
	HiLink bbcodeItalicUnderlineBold bbcodeBoldItalicUnderline
	HiLink bbcodeUnderlineBold bbcodeBoldUnderline
	HiLink bbcodeUnderlineBoldItalic bbcodeBoldItalicUnderline
	HiLink bbcodeUnderlineItalic bbcodeItalicUnderline
	HiLink bbcodeUnderlineItalicBold bbcodeBoldItalicUnderline

	delcommand HiLink
endif

hi def bbcodeBold term=bold cterm=bold gui=bold
hi def bbcodeBoldItalic term=bold,italic cterm=bold,italic gui=bold,italic
hi def bbcodeBoldItalicUnderline term=bold,italic,underline cterm=bold,italic,underline gui=bold,italic,underline
hi def bbcodeBoldUnderline term=bold,underline cterm=bold,underline gui=bold,underline
hi def bbcodeItalic term=italic cterm=italic gui=italic
hi def bbcodeItalicUnderline term=italic,underline cterm=italic,underline gui=italic,underline
hi def bbcodeUnderline term=underline cterm=underline gui=underline

let b:current_syntax = "bbcode"
